package apps;

import java.util.List;

import com.ibm.rhapsody.apps.utils.Reporter;

public class MBDGSimpleModel {
	private int index = 0;
	private MBDGElement root;
	
	public MBDGSimpleModel() {
	}
	
	public StringBuilder getRootTemplate() {
		return root.getTemplate();
	}	

	public MBDGElement getRoot() {
		return root;
	}

	public void setRoot(MBDGElement root) {
		this.root = root;
		this.root.setRoot(true);
	}
	
	public void report() {
		index = 0;
		report(root);
	}	
	
	public void report(MBDGElement element) {
		if (!element.isRoot()) {
			String text = String.format("%d: %s", ++index, element.toString());
			Reporter.report(text);
		}
		List<MBDGElement> descendants = element.getDescendants();
		for (MBDGElement descendant : descendants) {
			report(descendant);
		}
	}
}
