package apps;

import java.lang.reflect.Method;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Shell;

import apps.NotificationDialog.PreviewStatus;

import com.ibm.rhapsody.apps.App;
import com.ibm.rhapsody.apps.AppInfo;
import com.ibm.rhapsody.apps.core.RAController;
import com.ibm.rhapsody.apps.utils.AppClassLoader;
import com.ibm.rhapsody.apps.utils.RAExpander;
import com.ibm.rhapsody.apps.utils.Reporter;
import com.telelogic.rhapsody.core.IRPApplication;
import com.telelogic.rhapsody.core.IRPModelElement;


public class PreviewApp extends App {
	App reportApp = null; 
	
	/*
	* This method is called on invoking an app inside Rhapsody.
	* rhapsody - Instance of an active Rhapsody application 
	* selected - Selected element in Rhapsody
	*/
	public void execute(IRPApplication rhapsody, IRPModelElement selected) {
		
    	NotificationDialog dialog = new NotificationDialog(new Shell(SWT.ON_TOP | SWT.SHELL_TRIM));
        dialog.setText("Model Based Document Generation ...");
        dialog.setMessage(String.format("Preview:  %s [%s]", selected.getName(), selected.getUserDefinedMetaClass()));
        dialog.open();
        
        if (dialog.getStatus() == PreviewStatus.Preview) {
        	preview(false);
        } else if (dialog.getStatus() == PreviewStatus.PreviewDescendants) {
        	preview(true);
        }
	}
	
	public void preview(Boolean withDescendants) {
		RAController controller = new RAController(rhapsody);
		controller.init();
		RAExpander.setConfiguration(controller.getConfiguration());
		
		AppInfo info = new AppInfo();
		info.setPath("mbdgGenerateDocument.jar");
		try {
			if (reportApp == null) {
				reportApp = new AppClassLoader().load(info, rhapsody);
			}
			reportApp.setRhapsody(rhapsody);
			Method m = reportApp.getClass().getMethod("preview", new Class[] {IRPModelElement.class, Boolean.class});
			m.invoke(reportApp, new Object[] {selected, withDescendants});			
		} catch (Exception e) {
			Reporter.report(e);
		}
	}	
	

    /*
     *  Debug app by launching it as "Java Application" is Eclipse.
	 *  Note: Select an element in Rhapsody in order to simulate launching app on a selected element in the browser.
     */	
	public static void main(String[] args) {
		PreviewApp app = new PreviewApp();
		app.invokeFromMain();
	}		
}
