package com.ibm.rhapsody.sysML.proxyportWizards;

import com.telelogic.rhapsody.core.IRPApplication;
import com.telelogic.rhapsody.core.IRPAttribute;
import com.telelogic.rhapsody.core.IRPClassifier;
import com.telelogic.rhapsody.core.IRPCollection;
import com.telelogic.rhapsody.core.IRPFlow;
import com.telelogic.rhapsody.core.IRPInstanceValue;
import com.telelogic.rhapsody.core.IRPModelElement;
import com.telelogic.rhapsody.core.IRPPort;
import com.telelogic.rhapsody.core.IRPTag;
import com.telelogic.rhapsody.core.IRPValueSpecification;
import com.telelogic.rhapsody.core.RPUserPlugin;
import com.telelogic.rhapsody.core.RhapsodyAppServer;

public class ProxyportWizardsPlugin extends RPUserPlugin {
	static IRPApplication rhapsody = null;
	@Override
	public void RhpPluginInit(IRPApplication rpyApplication) {
		rhapsody = rpyApplication;
		Utils.setRhapsody(rhapsody);
	}

	@Override
	public void RhpPluginInvokeItem() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void OnMenuItemSelect(String menuItem) {
		if(menuItem == null)
			return;
		
		if(menuItem.equals("SysML\\Elaborate Connector Via Ports..."))
			openWizard();
		else if(menuItem.equals("SysML\\Create/Update Proxyport...")) {
			createProxyport();
		}
		
	}

	@Override
	public void OnTrigger(String trigger) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public boolean RhpPluginCleanup() {
		return false;
	}

	@Override
	public void RhpPluginFinalCleanup() {
		rhapsody = null;
		
	}

	//table mapping callback functions
	public String fromPropertyWithContextAndType(String guid) {
		String fromProp = null;
		if(guid != null && rhapsody != null) {
			IRPModelElement elem = rhapsody.activeProject().findElementByGUID(guid);
			if(elem != null && elem instanceof IRPFlow) {
				IRPFlow flow = (IRPFlow)elem;
				IRPModelElement end1 = flow.getEnd1();
				IRPPort end1Port = flow.getEnd1Port();
				if(end1Port != null)
					end1 = end1Port;
				IRPClassifier type = null;
				if(end1 instanceof IRPAttribute) {
					IRPAttribute attr = (IRPAttribute)end1;
					type = attr.getType();
				}
				else if(end1 instanceof IRPPort) {
					IRPPort port = (IRPPort)end1;
					type = port.getOtherClass();
				}
				
				fromProp = end1.getName();
				String direction = Utils.getDirectionString(end1);
				if(direction != null && direction.isEmpty() == false)
					fromProp += "(" + direction + ")";
				if(type != null)
					fromProp += ":" + type.getName();
				
				//add context
				String contextStr = "";
				IRPTag tag = flow.getTag("SourceContext");
				if(tag != null) {
					IRPCollection context = tag.getValueSpecifications();
					if(context != null && context.getCount() > 0) {
						for(int i = 1 ; i <= context.getCount() ; i++) {
							IRPValueSpecification vs = (IRPValueSpecification)context.getItem(i);
							if(vs instanceof IRPInstanceValue) {
								IRPInstanceValue iv = (IRPInstanceValue)vs;
								IRPModelElement contextElem = iv.getValue();
								if(contextElem != null) {
									if(contextStr.isEmpty() == false)
										contextStr += ".";
									contextStr += contextElem.getName();
								}
							}
						}
					}
				}
				if(contextStr.isEmpty() == false)
					fromProp = contextStr + "." + fromProp;
			}
		}
		return fromProp;
	}
	
	public String toPropertyWithContextAndType(String guid) {
		String fromProp = null;
		if(guid != null && rhapsody != null) {
			IRPModelElement elem = rhapsody.activeProject().findElementByGUID(guid);
			if(elem != null && elem instanceof IRPFlow) {
				IRPFlow flow = (IRPFlow)elem;
				IRPModelElement end2 = flow.getEnd2();
				IRPPort end2Port = flow.getEnd2Port();
				if(end2Port != null)
					end2 = end2Port;
				IRPClassifier type = null;
				if(end2 instanceof IRPAttribute) {
					IRPAttribute attr = (IRPAttribute)end2;
					type = attr.getType();
				}
				else if(end2 instanceof IRPPort) {
					IRPPort port = (IRPPort)end2;
					type = port.getOtherClass();
				}
				
				fromProp = end2.getName();
				String direction = Utils.getDirectionString(end2);
				if(direction != null && direction.isEmpty() == false)
					fromProp += "(" + direction + ")";
				if(type != null)
					fromProp += ":" + type.getName();
				
				//add context
				String contextStr = "";
				IRPTag tag = flow.getTag("TargetContext");
				if(tag != null) {
					IRPCollection context = tag.getValueSpecifications();
					if(context != null && context.getCount() > 0) {
						for(int i = 1 ; i <= context.getCount() ; i++) {
							IRPValueSpecification vs = (IRPValueSpecification)context.getItem(i);
							if(vs instanceof IRPInstanceValue) {
								IRPInstanceValue iv = (IRPInstanceValue)vs;
								IRPModelElement contextElem = iv.getValue();
								if(contextElem != null) {
									if(contextStr.isEmpty() == false)
										contextStr += ".";
									contextStr += contextElem.getName();
								}
							}
						}
					}
				}
				if(contextStr.isEmpty() == false)
					fromProp = contextStr + "." + fromProp;
			}
		}
		return fromProp;
	}
	
	public static void main(String args[]) {
		rhapsody = RhapsodyAppServer.getActiveRhapsodyApplication();
		openWizard();
	}
	
	private static void openWizard() {
		try {
			ElaborateConnectorViaPortsWizard.openWizard(rhapsody);
		} catch (Exception e) {
			rhapsody.writeToOutputWindow("Log", e.getMessage());
		}
	}
	
	private static void createProxyport() {
		try {
			CreateProxyportShell.createDialog(rhapsody);
		} catch (Exception e) {
			rhapsody.writeToOutputWindow("Log", e.getMessage());
		}
	}
}
